#!/usr/bin/perl -w

# cette librairie sert &agrave; mieux afficher les erreurs, vous la palcez o&ugrave; vous voulez dans votre r&eacute;pertoire et changez le chemin ci-dessous en correspondance
BEGIN {unshift(@INC, '/usr/lib/perl5/5.005/');}
use CGI::Carp qw(carpout fatalsToBrowser croak confess);

# fichier test
my $test = 'flock.txt';
my $test_www = 'flock.txt';


# pour simuler la fonction gensym de la librairie Symbol
package My_symbol;
my $genpkg = "My_symbol::";
my $genseq = 0;
sub gensym () {
    my $name = "GEN" . $genseq++;
    local *{$genpkg . $name};
    \delete ${$genpkg}{$name};
}

package main;

# mode pour lock/delock 
my $LOCK_EX = 2;

my $fh = My_symbol::gensym();

print "Content-type: text/html\n\n"; 
print<<EOF
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN"> 
<HTML><HEAD><TITLE>Flock de $test</TITLE></HEAD>
<body>  
EOF
; 
print "<h1 align=center>Flock de $test</h1>\n";

print "Flock bloque un fichier de telle mani&egrave;re que plusieurs prog ne peuvent y &eacute;crire en m&ecirc;me temps. Cela garantit son int&eacute;grit&eacute;. Cette proc&eacute;dure, hyper pratique, n'est pas toujours en &eacute;tat de fonctionner (par exemple, sur un r&eacute;seau NFS comme &eacute;tait HOL). Elle prend comme argument le HANDLER du fichier.<BR><BR>Ce test sert juste &agrave; v&eacute;rifier si on peut utiliser cette proc&eacute;dure sans avoir d'erreur en &eacute;crivant le HANDLER de plusieurs mani&egrave;res. Il ne teste pas si flock marche effectivement cad avec au moins 2 prog essayant d'&eacute;crire ensemble dans un m&ecirc;me fichier<BR><BR>";

# test lock fichier
open($fh, ">$test") || confess("Can't open $test: $!");
if (!flock($fh,$LOCK_EX)) {
  print "flock merde avec HANDLER g&eacute;n&eacute;r&eacute; par gensym: $!<BR><BR>\n";
} else {
  print "flock OK avec HANDLER g&eacute;n&eacute;r&eacute; par gensym: on &eacute;crit 'aaa'<BR><BR>\n";
  print $fh "aaa\n";
}
close($fh) || confess("Can't close $test: $!");

# test lock fichier
$fh=TOTO;
open($fh, ">>$test") || confess("Can't open $test: $!");
if (!flock($fh,$LOCK_EX)) {
  print "flock merde avec HANDLER manuel dans variable \$fh=TOTO:  $!<BR><BR>\n";
} else {
  print "flock OK avec HANDLER manuel dans variable \$fh=TOTO: on &eacute;crit 'bbb'<BR><BR>\n";
  print $fh "bbb\n";
}
close($fh) || confess("Can't close $test: $!");

# test lock fichier
open(TEST, ">>$test") || confess("Can't open $test: $!");
if (!flock(TEST,$LOCK_EX)) {
  print "flock merde avec HANDLER manuel: $!<BR><BR>\n";
}   else {
  print "flock OK avec HANDLER manuel: on &eacute;crit 'ccc'<BR><BR>\n";
  print TEST "ccc\n";
}
close(TEST) || confess("Can't close $test: $!");

print "<br><A HREF=\"$test_www\">Voir le fichier</A><BR>\n";

print "</body></html>";
